#-----------------------------------------------------------------------------
#
#  ####   #    #  #####    ####   #####   #####           #####   #
# #       #    #  #    #  #       #    #  #    #          #    #  #
#  ####   #    #  #####    ####   #    #  #####           #    #  #
#      #  #    #  #    #       #  #    #  #    #   ###    #####   #
# #    #  #    #  #    #  #    #  #    #  #    #   ###    #       #
#  ####    ####   #####    ####   #####   #####    ###    #       ######
#
#-----------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub disconnectDB
#------------------------------------------------------------------------------
{
  $dbh->disconnect || &error("Disconnection failed: $DBI::errstr");
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
# Changes:
#   2012/09/24 BB: Changed LongReadLen from 8000 to 16000
#------------------------------------------------------------------------------
{
  $connect_verbose = $_[0];
  $connect_debug = $_[1];
  use DBI;

  &setEnv; 
  ##system("env | grep ^DBAMON"); 
  $dbms = $ENV{"DBAMON_REPOS_DBMS"}; 

  if ($dbms eq "Oracle" || ! $dbms)
  {
    $user = "dbamon";
    $passwd = $oracle_password;
    $data_source = "DBI:Oracle";
    $database = $os;
    %attr = (
      PrintError => 0
    );
    ##&logit("connectDB - Connecting to Repository - Oracle - ORACLE_SID=$ENV{'ORACLE_SID'}"); 
    $dbh = DBI->connect("$data_source:$database", $user, $passwd, \%attr) ||
      &error("Cannot CONNECT to Oracle DB - ORACLE_SID=$ENV{'ORACLE_SID'}","","","Y");  # Fatal error
    $dbamon_repos = "O"; 
  }
  else
  {
    $mssql_instance = $ENV{"DBAMON_MSSQL_INSTANCE"}; 
    ##$DSN = "driver={SQL Server};Server=$mssql_instance;uid=;pwd=;MARS_Connection=Yes;";    #---- this WORKS
    $DSN = "driver={SQL Server};Server=$mssql_instance;uid=;pwd=;";    #---- this WORKS
    ##&logit("Connecting to MSSQL Repository - mssql_instance=$mssql_instance DSN=$DSN") ;
    #{ PrintError => 1,
    #  MARS_Connection => Yes, 
    #  odbc_cursortype => 2,
    #  odbc_cursortype => DBI::SQL_CURSOR_DYNAMIC,
    #  RaiseError => 0 } ) || &error("DBConnect");
    ##$dbh->{odbc_cursortype} = 2;
    &msg("Connecting to MSSQL Repository - mssql_instance=$mssql_instance DSN=$DSN") if $connect_verbose;

    ##$dbh = DBI->connect("dbi:ODBC:$DSN", { PrintError => 1, RaiseError => 0 } ) || &error("DBConnect");
    $dbh = DBI->connect("dbi:ODBC:$DSN", { PrintError => 0, RaiseError => 0 } ) || &error("DBConnect");

    #---- Some housekeeping SQL
    $dbh->{odbc_SQL_ROWSET_SIZE} = 2;
    $dbh->{PrintError} = 0;
    #  odbc_cursortype => 2,
    $sth = $dbh->do("use dbamon") || &error("Use_DBAMON");

    #---- Old
    #$sql = "IF OBJECT_ID (N'dbamon.dateconvert_19', N'FN') IS NOT NULL DROP FUNCTION dbamon.dateconvert_19;"; 
    #&msg("DEBUG - Running SQL=$sql") if $connect_debug; 
    #$sth = $dbh->do($sql) || &error("DROP_F1");
    #$sql = "CREATE FUNCTION dbamon.dateconvert_19 (\@DATE datetime2)
    #  RETURNS varchar(19)
    #  WITH EXECUTE AS CALLER
    #  AS
    #  BEGIN
    #	   DECLARE \@RESULT varchar(19);
    #	   SET \@RESULT = CONVERT(varchar(10), \@DATE, 111) + 
    #                    '-' + CONVERT(varchar(8),  \@DATE, 108);
    #	   RETURN(\@RESULT);
    #      END;
    #"; 

    #---- New
    $sql = "CREATE FUNCTION dbamon.dateconvert_19 (\@DATE datetime2)
      RETURNS varchar(19)
      WITH EXECUTE AS CALLER
      AS
      BEGIN
	   DECLARE \@RESULT varchar(19);
	   SET \@RESULT = CONVERT(varchar(10), \@DATE, 111) + 
                    '-' + CONVERT(varchar(8),  \@DATE, 108);
	   RETURN(\@RESULT);
      END;
    "; 
    &msg("DEBUG - Running SQL=$sql") if $connect_debug; 
    $sqlerrflag = 0;
    $sth = $dbh->do($sql) || ($sqlerrflag = 1); 
    if ($sqlerrflag)
    {
      if ($DBI::errstr =~ /already an object/)  
      { 
        ##&msg("Object dataconvert_19 already exists - This is OK"); 
      }
      else { &error("Error creating dataconvert19 function"); }
    }

    #---- Old
    #$sth = $dbh->do("use dbamon") || &error("Use_DBAMON");
    #$sql = "IF OBJECT_ID (N'dbamon.dateconvert_10', N'FN') IS NOT NULL DROP FUNCTION dbamon.dateconvert_10;"; 
    #&msg("DEBUG - Running SQL=$sql") if $connect_debug; 
    #$sth = $dbh->do($sql) || &error("DROP_F2");
    ###$sth = $dbh->do("go") || &error("DROP_F2");
    #$sql = "CREATE FUNCTION dbamon.dateconvert_10 (\@DATE datetime2)
    #  RETURNS varchar(10)
    #  WITH EXECUTE AS CALLER
    #  AS
    #  BEGIN
    #	   DECLARE \@RESULT varchar(10);
    #	   SET \@RESULT = CONVERT(varchar(10), \@DATE, 111);
    #	   RETURN(\@RESULT);
    #      END;
    #    "; 
    #    &msg("DEBUG - Running SQL=$sql") if $connect_debug; 
    #    $sth = $dbh->do($sql) || &error("Create_F2");

    #---- New
    $sql = "CREATE FUNCTION dbamon.dateconvert_10 (\@DATE datetime2)
      RETURNS varchar(10)
      WITH EXECUTE AS CALLER
      AS
      BEGIN
	   DECLARE \@RESULT varchar(10);
	   SET \@RESULT = CONVERT(varchar(10), \@DATE, 111);
	   RETURN(\@RESULT);
      END;
    "; 
    &msg("DEBUG - Running SQL=$sql") if $connect_debug; 
    $sqlerrflag = 0;
    $sth = $dbh->do($sql) || ($sqlerrflag = 1); 
    if ($sqlerrflag)
    {
      if ($DBI::errstr =~ /already an object/)
      {
        ##&msg("Object dataconvert_10 already exists - This is OK"); 
      }
      else { &error("Error creating dataconvert19 function"); }
    }

    #---- Set variable
    $dbamon_repos = "M"; 
  }

  #---- Common settings
  ##$dbh->{LongReadLen} = 4000;
  ##$dbh->{LongReadLen} = 40000;
  $dbh->{LongReadLen} = 16000;
  
  &msg("Connected OK") if $connect_verbose;
  ##print "dbh=$dbh  \n";
}

#-----------------------------------------------------------------------------
sub runSQL
#-----------------------------------------------------------------------------
{
  my ($sqlstmt,$nosqlerror) = @_;
  ##print "dbh=$dbh sqlstmt=$sqlstmt \n";

  #if ($use_oracle ne "Y" && $repos ne "M")
  #{
  #  print "Error - should not be here - routine=$routine \n";
  #  return;
  #}

  if (
       $DBI::errstr =~ /ORA-03114/ ||   # no connection
       $DBI::errstr =~ /ORA-01012/ ||   # not logged on
       $DBI::errstr =~ /ORA-00028/      # session killed
     )
  {
    &error_fatal("DBAmon Lost ORACLE Connection - SQL Error=$DBI::errstr","","","Y");
  }

  if ($nosqlerror)
  {
    $sqlrc = $dbh->do($sqlstmt);
  }
  else
  {
    ##print "REPOS SQL - dbh=$dbh sqlstmt=$sqlstmt \n";
    $sqlrc = $dbh->do($sqlstmt) || &error_fatal("FATAL SQL Error=$DBI::errstr SQL Statement=($sqlstmt) Failure");
  }
  $sqlerror = $DBI::errstr;
  $sqlcode = $dbh->err;
  $sqlrows = $dbh->rows;
  return $sqlrc;
}

#-----------------------------------------------------------------------------
sub runSQLBind
#-----------------------------------------------------------------------------
{
  ($sqlstmt) = @_;
  ##print "dbh=$dbh sqlstmt=$sqlstmt \n";

  #if ($use_oracle ne "Y")
  #{
  #  print "Error - should not be here - routine=$routine \n";
  #  return;
  #}

  if (
       $DBI::errstr =~ /ORA-03114/ ||   # no connection
       $DBI::errstr =~ /ORA-01012/ ||   # not logged on
       $DBI::errstr =~ /ORA-00028/      # session killed
     )
  {
    &error_fatal("DBAmon Lost ORACLE Connection - SQL Error=$DBI::errstr","","","Y");
  }

  $sth = $dbh->prepare($sqlstmt) || &error_fatal("SQL Error=$DBI::errstr SQL Statement=$sqlstmt Failure");

  $sth->bind_param(1, $bind_1);

  $sqlrc = $sth->execute || &error_fatal("SQL Error=$DBI::errstr SQL Statement=$sqlstmt Failure"); 
  
  $sqlerror = $DBI::errstr;
  $sqlcode = $dbh->err;
  $sqlrows = $dbh->rows;
  return $sqlrc;
}

1;
